import { __awaiter, __generator, __spread } from 'tslib';
import { Component, NgModule } from '@angular/core';
import { ToastController, LoadingController, IonicModule } from '@ionic/angular';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { Router, RouterModule } from '@angular/router';
import { delay } from 'bluebird';
import { EdgeCentralClient } from '@sirusdev/ec-client-angular';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/login.page.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoginPage = /** @class */ (function () {
    function LoginPage(toast, loading, router, ec) {
        this.toast = toast;
        this.loading = loading;
        this.router = router;
        this.ec = ec;
        this.tab = 'device';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    LoginPage.prototype.tabChanged = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.tab = event.detail.value;
    };
    /**
     * @param {?} form
     * @return {?}
     */
    LoginPage.prototype.loginDevice = /**
     * @param {?} form
     * @return {?}
     */
    function (form) {
        return __awaiter(this, void 0, void 0, function () {
            var loading, err_1, toast;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!form.valid) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.loading.create({
                                message: 'Menghubungkan...'
                            })];
                    case 1:
                        loading = _a.sent();
                        return [4 /*yield*/, loading.present()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 6, , 9]);
                        return [4 /*yield*/, this.ec.loginByDevice(this.deviceID)];
                    case 4:
                        _a.sent();
                        // wait local storage to persist
                        return [4 /*yield*/, delay(500)];
                    case 5:
                        // wait local storage to persist
                        _a.sent();
                        window.location.replace('/');
                        return [3 /*break*/, 9];
                    case 6:
                        err_1 = _a.sent();
                        return [4 /*yield*/, this.toast.create({
                                message: err_1.message || err_1.toString(),
                                color: 'danger',
                                duration: 5000
                            })];
                    case 7:
                        toast = _a.sent();
                        return [4 /*yield*/, toast.present()];
                    case 8:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 9: return [4 /*yield*/, loading.dismiss()];
                    case 10:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    LoginPage.prototype.loginProvider = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var loading, err_2, toast;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loading.create({
                            message: 'Menghubungkan...'
                        })];
                    case 1:
                        loading = _a.sent();
                        return [4 /*yield*/, loading.present()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 6, , 9]);
                        return [4 /*yield*/, this.ec.loginByProvider(this.providerID, this.password)];
                    case 4:
                        _a.sent();
                        // wait local storage to persist
                        return [4 /*yield*/, delay(500)];
                    case 5:
                        // wait local storage to persist
                        _a.sent();
                        window.location.replace('/');
                        return [3 /*break*/, 9];
                    case 6:
                        err_2 = _a.sent();
                        return [4 /*yield*/, this.toast.create({
                                message: err_2.message || err_2.toString(),
                                color: 'danger',
                                duration: 5000
                            })];
                    case 7:
                        toast = _a.sent();
                        return [4 /*yield*/, toast.present()];
                    case 8:
                        _a.sent();
                        return [3 /*break*/, 9];
                    case 9: return [4 /*yield*/, loading.dismiss()];
                    case 10:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LoginPage.decorators = [
        { type: Component, args: [{
                    selector: 'qh-login-page',
                    template: "<ion-header translucent>\r\n  <ion-toolbar>\r\n    <ion-title>Login</ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n<ion-content>\r\n  <ion-grid>\r\n    <ion-row class=\"ion-align-items-center ion-justify-content-center\">\r\n      <ion-col size-md=\"8\" size-sm>\r\n        <ion-card>\r\n          <ion-card-header>\r\n            <ion-segment (ionChange)=\"tabChanged($event)\" [value]=\"tab\">\r\n              <ion-segment-button value=\"device\" id=\"login-device\">\r\n                <ion-label>Login dengan kode perangkat</ion-label>\r\n              </ion-segment-button>\r\n              <ion-segment-button value=\"provider\" id=\"login-provider\">\r\n                <ion-label>Login dengan kode faskes</ion-label>\r\n              </ion-segment-button>\r\n            </ion-segment>\r\n          </ion-card-header>\r\n\r\n          <ion-card-content>\r\n            <ng-container *ngIf=\"tab === 'device'\">\r\n              <form\r\n                ngForm\r\n                #loginDeviceForm=\"ngForm\"\r\n                (ngSubmit)=\"loginDevice(loginDeviceForm)\"\r\n              >\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode perangkat\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"device_id.invalid && (device_id.dirty || device_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"device_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"device_id\"\r\n                      [(ngModel)]=\"deviceID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal prkt123\"\r\n                      required\r\n                      #device_id=\"ngModel\"\r\n                      id=\"device-id\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    type=\"submit\"\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginDevice(loginDeviceForm)\"\r\n                    [disabled]=\"!loginDeviceForm.form.valid\"\r\n                    id=\"submit-device\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n\r\n            <ng-container *ngIf=\"tab === 'provider'\">\r\n              <form ngForm #loginProviderForm=\"ngForm\">\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode faskes\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"provider_id.invalid && (provider_id.dirty || provider_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"provider_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"provider_id\"\r\n                      [(ngModel)]=\"providerID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal klinik_sehat\"\r\n                      required\r\n                      #provider_id=\"ngModel\"\r\n                      id=\"provider-code\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      password\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"passwords.invalid && (passwords.dirty || passwords.touched)\"\r\n                      >\r\n                        <span *ngIf=\"passwords?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"password\"\r\n                      [(ngModel)]=\"password\"\r\n                      type=\"password\"\r\n                      required\r\n                      #passwords=\"ngModel\"\r\n                      id=\"provider-password\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginProvider()\"\r\n                    [disabled]=\"!loginProviderForm.form.valid\"\r\n                    id=\"submit-provider\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n          </ion-card-content>\r\n        </ion-card>\r\n      </ion-col>\r\n    </ion-row>\r\n  </ion-grid>\r\n</ion-content>\r\n"
                }] }
    ];
    /** @nocollapse */
    LoginPage.ctorParameters = function () { return [
        { type: ToastController },
        { type: LoadingController },
        { type: Router },
        { type: EdgeCentralClient }
    ]; };
    return LoginPage;
}());
if (false) {
    /** @type {?} */
    LoginPage.prototype.tab;
    /** @type {?} */
    LoginPage.prototype.deviceID;
    /** @type {?} */
    LoginPage.prototype.providerID;
    /** @type {?} */
    LoginPage.prototype.password;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.toast;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.loading;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.router;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.ec;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec-login.router.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var routes = [{ path: '', component: LoginPage }];
/**
 * Login Router modules
 * @export
 */
var EdgeCentralLoginRoutingModule = /** @class */ (function () {
    function EdgeCentralLoginRoutingModule() {
    }
    EdgeCentralLoginRoutingModule.decorators = [
        { type: NgModule, args: [{
                    imports: [RouterModule.forChild(routes)],
                    exports: [RouterModule],
                    declarations: []
                },] }
    ];
    return EdgeCentralLoginRoutingModule;
}());
/** @type {?} */
var routedComponents = [LoginPage];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec-login.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Module to provide context user interface before accessing edge central features
 *
 * @export
 */
var EdgeCentralLoginModule = /** @class */ (function () {
    function EdgeCentralLoginModule() {
    }
    EdgeCentralLoginModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        IonicModule,
                        CommonModule,
                        EdgeCentralLoginRoutingModule,
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    declarations: __spread(routedComponents)
                },] }
    ];
    return EdgeCentralLoginModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: sirusdev-ec-client-angular-login.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { EdgeCentralLoginModule, EdgeCentralLoginRoutingModule as ɵa, routedComponents as ɵb, LoginPage as ɵc };
//# sourceMappingURL=sirusdev-ec-client-angular-login.js.map
