import { ModuleWithProviders } from '@angular/core';
import { EdgeCentralConfig, EdgeCentralClient } from './services/ec.service';
/**
 * Load apollo client on booting
 */
export declare function initEdgeCentralClient(ec: EdgeCentralClient): () => Promise<void>;
/**
 * wrapped edge central client so it injectable
 */
export declare function provideEdgeCentralService(config: EdgeCentralConfig): EdgeCentralClient;
/**
 *
 * @export
 */
export declare class EdgeCentralModule {
    /**
     * Creates an instance of EdgeCentralModule.
     * throw error if EdgeCentralModule already created on parent
     */
    constructor(parentModule: EdgeCentralModule);
    /**
     * Create new module instance with edge central config service
     *
     */
    static forRoot(config: EdgeCentralConfig): ModuleWithProviders;
}
